Index: t3lib/class.t3lib_div.php
===================================================================
--- t3lib/class.t3lib_div.php	(revision 9354)
+++ t3lib/class.t3lib_div.php	(revision )
@@ -1,29 +1,29 @@
 <?php
 /***************************************************************
-*  Copyright notice
-*
-*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
-*  All rights reserved
-*
-*  This script is part of the TYPO3 project. The TYPO3 project is
-*  free software; you can redistribute it and/or modify
-*  it under the terms of the GNU General Public License as published by
-*  the Free Software Foundation; either version 2 of the License, or
-*  (at your option) any later version.
-*
-*  The GNU General Public License can be found at
-*  http://www.gnu.org/copyleft/gpl.html.
-*  A copy is found in the textfile GPL.txt and important notices to the license
-*  from the author is found in LICENSE.txt distributed with these scripts.
-*
-*
-*  This script is distributed in the hope that it will be useful,
-*  but WITHOUT ANY WARRANTY; without even the implied warranty of
-*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*  GNU General Public License for more details.
-*
-*  This copyright notice MUST APPEAR in all copies of the script!
-***************************************************************/
+ *  Copyright notice
+ *
+ *  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+ *  All rights reserved
+ *
+ *  This script is part of the TYPO3 project. The TYPO3 project is
+ *  free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  The GNU General Public License can be found at
+ *  http://www.gnu.org/copyleft/gpl.html.
+ *  A copy is found in the textfile GPL.txt and important notices to the license
+ *  from the author is found in LICENSE.txt distributed with these scripts.
+ *
+ *
+ *  This script is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  This copyright notice MUST APPEAR in all copies of the script!
+ ***************************************************************/
 /**
  * Contains the reknown class "t3lib_div" with general purpose functions
  *
@@ -41,161 +41,161 @@
  *
  *  232: class t3lib_div
  *
- *              SECTION: GET/POST Variables
+ *			  SECTION: GET/POST Variables
- *  262:     function _GP($var)
+ *  262:	 function _GP($var)
- *  280:     function _GET($var=NULL)
+ *  280:	 function _GET($var=NULL)
- *  297:     function _POST($var=NULL)
+ *  297:	 function _POST($var=NULL)
- *  313:     function _GETset($inputGet,$key='')
+ *  313:	 function _GETset($inputGet,$key='')
- *  336:     function GPvar($var,$strip=0)
+ *  336:	 function GPvar($var,$strip=0)
- *  353:     function GParrayMerged($var)
+ *  353:	 function GParrayMerged($var)
  *
- *              SECTION: IMAGE FUNCTIONS
+ *			  SECTION: IMAGE FUNCTIONS
- *  397:     function gif_compress($theFile, $type)
+ *  397:	 function gif_compress($theFile, $type)
- *  425:     function png_to_gif_by_imagemagick($theFile)
+ *  425:	 function png_to_gif_by_imagemagick($theFile)
- *  450:     function read_png_gif($theFile,$output_png=0)
+ *  450:	 function read_png_gif($theFile,$output_png=0)
  *
- *              SECTION: STRING FUNCTIONS
+ *			  SECTION: STRING FUNCTIONS
- *  499:     function fixed_lgd($string,$origChars,$preStr='...')
+ *  499:	 function fixed_lgd($string,$origChars,$preStr='...')
- *  524:     function fixed_lgd_pre($string,$chars)
+ *  524:	 function fixed_lgd_pre($string,$chars)
- *  538:     function fixed_lgd_cs($string,$chars)
+ *  538:	 function fixed_lgd_cs($string,$chars)
- *  555:     function breakTextForEmail($str,$implChar=LF,$charWidth=76)
+ *  555:	 function breakTextForEmail($str,$implChar=LF,$charWidth=76)
- *  574:     function breakLinesForEmail($str,$implChar=LF,$charWidth=76)
+ *  574:	 function breakLinesForEmail($str,$implChar=LF,$charWidth=76)
- *  610:     function cmpIP($baseIP, $list)
+ *  610:	 function cmpIP($baseIP, $list)
- *  626:     function cmpIPv4($baseIP, $list)
+ *  626:	 function cmpIPv4($baseIP, $list)
- *  668:     function cmpIPv6($baseIP, $list)
+ *  668:	 function cmpIPv6($baseIP, $list)
- *  711:     function IPv6Hex2Bin ($hex)
+ *  711:	 function IPv6Hex2Bin ($hex)
- *  726:     function normalizeIPv6($address)
+ *  726:	 function normalizeIPv6($address)
- *  782:     function validIPv6($ip)
+ *  782:	 function validIPv6($ip)
- *  805:     function cmpFQDN($baseIP, $list)
+ *  805:	 function cmpFQDN($baseIP, $list)
- *  835:     function inList($list,$item)
+ *  835:	 function inList($list,$item)
- *  847:     function rmFromList($element,$list)
+ *  847:	 function rmFromList($element,$list)
- *  863:     function expandList($list)
+ *  863:	 function expandList($list)
- *  894:     function intInRange($theInt,$min,$max=2000000000,$zeroValue=0)
+ *  894:	 function intInRange($theInt,$min,$max=2000000000,$zeroValue=0)
- *  910:     function intval_positive($theInt)
+ *  910:	 function intval_positive($theInt)
- *  923:     function int_from_ver($verNumberStr)
+ *  923:	 function int_from_ver($verNumberStr)
- *  934:     function compat_version($verNumberStr)
+ *  934:	 function compat_version($verNumberStr)
- *  952:     function md5int($str)
+ *  952:	 function md5int($str)
- *  965:     function shortMD5($input, $len=10)
+ *  965:	 function shortMD5($input, $len=10)
- *  978:     function uniqueList($in_list, $secondParameter=NULL)
+ *  978:	 function uniqueList($in_list, $secondParameter=NULL)
- *  992:     function split_fileref($fileref)
+ *  992:	 function split_fileref($fileref)
- * 1030:     function dirname($path)
+ * 1030:	 function dirname($path)
- * 1046:     function modifyHTMLColor($color,$R,$G,$B)
+ * 1046:	 function modifyHTMLColor($color,$R,$G,$B)
- * 1066:     function modifyHTMLColorAll($color,$all)
+ * 1066:	 function modifyHTMLColorAll($color,$all)
- * 1077:     function rm_endcomma($string)
+ * 1077:	 function rm_endcomma($string)
- * 1090:     function danish_strtoupper($string)
+ * 1090:	 function danish_strtoupper($string)
- * 1105:     function convUmlauts($str)
+ * 1105:	 function convUmlauts($str)
- * 1118:     function testInt($var)
+ * 1118:	 function testInt($var)
- * 1130:     function isFirstPartOfStr($str,$partStr)
+ * 1130:	 function isFirstPartOfStr($str,$partStr)
- * 1146:     function formatSize($sizeInBytes,$labels='')
+ * 1146:	 function formatSize($sizeInBytes,$labels='')
- * 1181:     function convertMicrotime($microtime)
+ * 1181:	 function convertMicrotime($microtime)
- * 1195:     function splitCalc($string,$operators)
+ * 1195:	 function splitCalc($string,$operators)
- * 1217:     function calcPriority($string)
+ * 1217:	 function calcPriority($string)
- * 1258:     function calcParenthesis($string)
+ * 1258:	 function calcParenthesis($string)
- * 1284:     function htmlspecialchars_decode($value)
+ * 1284:	 function htmlspecialchars_decode($value)
- * 1299:     function deHSCentities($str)
+ * 1299:	 function deHSCentities($str)
- * 1312:     function slashJS($string,$extended=0,$char="'")
+ * 1312:	 function slashJS($string,$extended=0,$char="'")
- * 1325:     function rawUrlEncodeJS($str)
+ * 1325:	 function rawUrlEncodeJS($str)
- * 1337:     function rawUrlEncodeFP($str)
+ * 1337:	 function rawUrlEncodeFP($str)
- * 1348:     function validEmail($email)
+ * 1348:	 function validEmail($email)
- * 1363:     function formatForTextarea($content)
+ * 1363:	 function formatForTextarea($content)
  *
- *              SECTION: ARRAY FUNCTIONS
+ *			  SECTION: ARRAY FUNCTIONS
- * 1394:     function inArray($in_array,$item)
+ * 1394:	 function inArray($in_array,$item)
- * 1411:     function intExplode($delim, $string)
+ * 1411:	 function intExplode($delim, $string)
- * 1430:     function revExplode($delim, $string, $count=0)
+ * 1430:	 function revExplode($delim, $string, $count=0)
- * 1450:     function trimExplode($delim, $string, $onlyNonEmptyValues=0)
+ * 1450:	 function trimExplode($delim, $string, $onlyNonEmptyValues=0)
- * 1472:     function uniqueArray($valueArray)
+ * 1472:	 function uniqueArray($valueArray)
- * 1484:     function removeArrayEntryByValue($array,$cmpValue)
+ * 1484:	 function removeArrayEntryByValue($array,$cmpValue)
- * 1513:     function implodeArrayForUrl($name,$theArray,$str='',$skipBlank=0,$rawurlencodeParamName=0)
+ * 1513:	 function implodeArrayForUrl($name,$theArray,$str='',$skipBlank=0,$rawurlencodeParamName=0)
- * 1538:     function explodeUrl2Array($string,$multidim=FALSE)
+ * 1538:	 function explodeUrl2Array($string,$multidim=FALSE)
- * 1564:     function compileSelectedGetVarsFromArray($varList,$getArray,$GPvarAlt=1)
+ * 1564:	 function compileSelectedGetVarsFromArray($varList,$getArray,$GPvarAlt=1)
- * 1587:     function addSlashesOnArray(&$theArray)
+ * 1587:	 function addSlashesOnArray(&$theArray)
- * 1611:     function stripSlashesOnArray(&$theArray)
+ * 1611:	 function stripSlashesOnArray(&$theArray)
- * 1633:     function slashArray($arr,$cmd)
+ * 1633:	 function slashArray($arr,$cmd)
- * 1650:     function array_merge_recursive_overrule($arr0,$arr1,$notAddKeys=0,$includeEmtpyValues=true)
+ * 1650:	 function array_merge_recursive_overrule($arr0,$arr1,$notAddKeys=0,$includeEmtpyValues=true)
- * 1683:     function array_merge($arr1,$arr2)
+ * 1683:	 function array_merge($arr1,$arr2)
- * 1696:     function csvValues($row,$delim=',',$quote='"')
+ * 1696:	 function csvValues($row,$delim=',',$quote='"')
  *
- *              SECTION: HTML/XML PROCESSING
+ *			  SECTION: HTML/XML PROCESSING
- * 1738:     function get_tag_attributes($tag)
+ * 1738:	 function get_tag_attributes($tag)
- * 1775:     function split_tag_attributes($tag)
+ * 1775:	 function split_tag_attributes($tag)
- * 1809:     function implodeAttributes($arr,$xhtmlSafe=FALSE,$dontOmitBlankAttribs=FALSE)
+ * 1809:	 function implodeAttributes($arr,$xhtmlSafe=FALSE,$dontOmitBlankAttribs=FALSE)
- * 1836:     function implodeParams($arr,$xhtmlSafe=FALSE,$dontOmitBlankAttribs=FALSE)
+ * 1836:	 function implodeParams($arr,$xhtmlSafe=FALSE,$dontOmitBlankAttribs=FALSE)
- * 1851:     function wrapJS($string, $linebreak=TRUE)
+ * 1851:	 function wrapJS($string, $linebreak=TRUE)
- * 1882:     function xml2tree($string,$depth=999)
+ * 1882:	 function xml2tree($string,$depth=999)
- * 1969:     function array2xml($array,$NSprefix='',$level=0,$docTag='phparray',$spaceInd=0, $options=array(),$stackData=array())
+ * 1969:	 function array2xml($array,$NSprefix='',$level=0,$docTag='phparray',$spaceInd=0, $options=array(),$stackData=array())
- * 2088:     function xml2array($string,$NSprefix='',$reportDocTag=FALSE)
+ * 2088:	 function xml2array($string,$NSprefix='',$reportDocTag=FALSE)
- * 2198:     function xmlRecompileFromStructValArray($vals)
+ * 2198:	 function xmlRecompileFromStructValArray($vals)
- * 2242:     function xmlGetHeaderAttribs($xmlData)
+ * 2242:	 function xmlGetHeaderAttribs($xmlData)
  *
- *              SECTION: FILES FUNCTIONS
+ *			  SECTION: FILES FUNCTIONS
- * 2275:     function getURL($url, $includeHeader=0)
+ * 2275:	 function getURL($url, $includeHeader=0)
- * 2342:     function writeFile($file,$content)
+ * 2342:	 function writeFile($file,$content)
- * 2367:     function fixPermissions($file)
+ * 2367:	 function fixPermissions($file)
- * 2384:     function writeFileToTypo3tempDir($filepath,$content)
+ * 2384:	 function writeFileToTypo3tempDir($filepath,$content)
- * 2427:     function mkdir($theNewFolder)
+ * 2427:	 function mkdir($theNewFolder)
- * 2446:     function mkdir_deep($destination,$deepDir)
+ * 2446:	 function mkdir_deep($destination,$deepDir)
- * 2468:     function get_dirs($path)
+ * 2468:	 function get_dirs($path)
- * 2493:     function getFilesInDir($path,$extensionList='',$prependPath=0,$order='')
+ * 2493:	 function getFilesInDir($path,$extensionList='',$prependPath=0,$order='')
- * 2547:     function getAllFilesAndFoldersInPath($fileArr,$path,$extList='',$regDirs=0,$recursivityLevels=99)
+ * 2547:	 function getAllFilesAndFoldersInPath($fileArr,$path,$extList='',$regDirs=0,$recursivityLevels=99)
- * 2570:     function removePrefixPathFromList($fileArr,$prefixToRemove)
+ * 2570:	 function removePrefixPathFromList($fileArr,$prefixToRemove)
- * 2586:     function fixWindowsFilePath($theFile)
+ * 2586:	 function fixWindowsFilePath($theFile)
- * 2598:     function resolveBackPath($pathStr)
+ * 2598:	 function resolveBackPath($pathStr)
- * 2626:     function locationHeaderUrl($path)
+ * 2626:	 function locationHeaderUrl($path)
  *
- *              SECTION: DEBUG helper FUNCTIONS
+ *			  SECTION: DEBUG helper FUNCTIONS
- * 2666:     function debug_ordvalue($string,$characters=100)
+ * 2666:	 function debug_ordvalue($string,$characters=100)
- * 2683:     function view_array($array_in)
+ * 2683:	 function view_array($array_in)
- * 2711:     function print_array($array_in)
+ * 2711:	 function print_array($array_in)
- * 2726:     function debug($var="",$brOrHeader=0)
+ * 2726:	 function debug($var="",$brOrHeader=0)
- * 2757:     function debug_trail()
+ * 2757:	 function debug_trail()
- * 2779:     function debugRows($rows,$header='')
+ * 2779:	 function debugRows($rows,$header='')
  *
- *              SECTION: SYSTEM INFORMATION
+ *			  SECTION: SYSTEM INFORMATION
- * 2857:     function getThisUrl()
+ * 2857:	 function getThisUrl()
- * 2873:     function linkThisScript($getParams=array())
+ * 2873:	 function linkThisScript($getParams=array())
- * 2897:     function linkThisUrl($url,$getParams=array())
+ * 2897:	 function linkThisUrl($url,$getParams=array())
- * 2920:     function getIndpEnv($getEnvName)
+ * 2920:	 function getIndpEnv($getEnvName)
- * 3113:     function milliseconds()
+ * 3113:	 function milliseconds()
- * 3125:     function clientInfo($useragent='')
+ * 3125:	 function clientInfo($useragent='')
  *
- *              SECTION: TYPO3 SPECIFIC FUNCTIONS
+ *			  SECTION: TYPO3 SPECIFIC FUNCTIONS
- * 3212:     function getFileAbsFileName($filename,$onlyRelative=1,$relToTYPO3_mainDir=0)
+ * 3212:	 function getFileAbsFileName($filename,$onlyRelative=1,$relToTYPO3_mainDir=0)
- * 3248:     function validPathStr($theFile)
+ * 3248:	 function validPathStr($theFile)
- * 3259:     function isAbsPath($path)
+ * 3259:	 function isAbsPath($path)
- * 3270:     function isAllowedAbsPath($path)
+ * 3270:	 function isAllowedAbsPath($path)
- * 3287:     function verifyFilenameAgainstDenyPattern($filename)
+ * 3287:	 function verifyFilenameAgainstDenyPattern($filename)
- * 3305:     function upload_copy_move($source,$destination)
+ * 3305:	 function upload_copy_move($source,$destination)
- * 3331:     function upload_to_tempfile($uploadedFileName)
+ * 3331:	 function upload_to_tempfile($uploadedFileName)
- * 3349:     function unlink_tempfile($uploadedTempFileName)
+ * 3349:	 function unlink_tempfile($uploadedTempFileName)
- * 3365:     function tempnam($filePrefix)
+ * 3365:	 function tempnam($filePrefix)
- * 3379:     function stdAuthCode($uid_or_record,$fields='',$codeLength=8)
+ * 3379:	 function stdAuthCode($uid_or_record,$fields='',$codeLength=8)
- * 3410:     function cHashParams($addQueryParams)
+ * 3410:	 function cHashParams($addQueryParams)
- * 3433:     function hideIfNotTranslated($l18n_cfg_fieldValue)
+ * 3433:	 function hideIfNotTranslated($l18n_cfg_fieldValue)
- * 3448:     function readLLfile($fileRef,$langKey)
+ * 3448:	 function readLLfile($fileRef,$langKey)
- * 3472:     function readLLXMLfile($fileRef,$langKey)
+ * 3472:	 function readLLXMLfile($fileRef,$langKey)
- * 3589:     function llXmlAutoFileName($fileRef,$language)
+ * 3589:	 function llXmlAutoFileName($fileRef,$language)
- * 3633:     function loadTCA($table)
+ * 3633:	 function loadTCA($table)
- * 3653:     function resolveSheetDefInDS($dataStructArray,$sheet='sDEF')
+ * 3653:	 function resolveSheetDefInDS($dataStructArray,$sheet='sDEF')
- * 3686:     function resolveAllSheetsInDS($dataStructArray)
+ * 3686:	 function resolveAllSheetsInDS($dataStructArray)
- * 3715:     function callUserFunction($funcName,&$params,&$ref,$checkPrefix='user_',$silent=0)
+ * 3715:	 function callUserFunction($funcName,&$params,&$ref,$checkPrefix='user_',$silent=0)
- * 3813:     function &getUserObj($classRef,$checkPrefix='user_',$silent=0)
+ * 3813:	 function &getUserObj($classRef,$checkPrefix='user_',$silent=0)
- * 3871:     function &makeInstance($className)
+ * 3871:	 function &makeInstance($className)
- * 3883:     function makeInstanceClassName($className)
+ * 3883:	 function makeInstanceClassName($className)
- * 3897:     function &makeInstanceService($serviceType, $serviceSubType='', $excludeServiceKeys=array())
+ * 3897:	 function &makeInstanceService($serviceType, $serviceSubType='', $excludeServiceKeys=array())
- * 3961:     function plainMailEncoded($email,$subject,$message,$headers='',$enc='',$charset='',$dontEncodeHeader=false)
+ * 3961:	 function plainMailEncoded($email,$subject,$message,$headers='',$enc='',$charset='',$dontEncodeHeader=false)
- * 4031:     function quoted_printable($string,$maxlen=76)
+ * 4031:	 function quoted_printable($string,$maxlen=76)
- * 4078:     function encodeHeader($line,$enc='',$charset='ISO-8859-1')
+ * 4078:	 function encodeHeader($line,$enc='',$charset='ISO-8859-1')
- * 4121:     function substUrlsInPlainText($message,$urlmode='76',$index_script_url='')
+ * 4121:	 function substUrlsInPlainText($message,$urlmode='76',$index_script_url='')
- * 4155:     function makeRedirectUrl($inUrl,$l=0,$index_script_url='')
+ * 4155:	 function makeRedirectUrl($inUrl,$l=0,$index_script_url='')
- * 4182:     function freetypeDpiComp($font_size)
+ * 4182:	 function freetypeDpiComp($font_size)
- * 4194:     function initSysLog()
+ * 4194:	 function initSysLog()
- * 4251:     function sysLog($msg, $extKey, $severity=0)
+ * 4251:	 function sysLog($msg, $extKey, $severity=0)
- * 4334:     function devLog($msg, $extKey, $severity=0, $dataVar=FALSE)
+ * 4334:	 function devLog($msg, $extKey, $severity=0, $dataVar=FALSE)
- * 4355:     function arrayToLogString($arr, $valueList=array(), $valueLength=20)
+ * 4355:	 function arrayToLogString($arr, $valueList=array(), $valueLength=20)
- * 4378:     function imageMagickCommand($command, $parameters, $path='')
+ * 4378:	 function imageMagickCommand($command, $parameters, $path='')
- * 4425:     function unQuoteFilenames($parameters,$unQuote=FALSE)
+ * 4425:	 function unQuoteFilenames($parameters,$unQuote=FALSE)
- * 4459:     function quoteJSvalue($value, $inScriptTags = false)
+ * 4459:	 function quoteJSvalue($value, $inScriptTags = false)
  *
  * TOTAL FUNCTIONS: 138
  * (This index is automatically created/updated by the extension "extdeveval")
@@ -260,12 +260,18 @@
 	 * @param	string		GET/POST var to return
 	 * @return	mixed		POST var named $var and if not set, the GET var of the same name.
 	 */
-	public static function _GP($var)	{
+	public static function _GP($var) {
-		if(empty($var)) return;
+		if (empty($var)) {
+			return;
+		}
 		$value = isset($_POST[$var]) ? $_POST[$var] : $_GET[$var];
-		if (isset($value))	{
+		if (isset($value)) {
-			if (is_array($value))	{ self::stripSlashesOnArray($value); } else { $value = stripslashes($value); }
+			if (is_array($value)) {
+				self::stripSlashesOnArray($value);
+			} else {
+				$value = stripslashes($value);
-		}
+			}
+		}
 		return $value;
 	}
 
@@ -277,7 +283,7 @@
 	 */
 	public static function _GPmerged($parameter) {
 		$postParameter = (isset($_POST[$parameter]) && is_array($_POST[$parameter])) ? $_POST[$parameter] : array();
-		$getParameter  = (isset($_GET[$parameter]) && is_array($_GET[$parameter])) ? $_GET[$parameter] : array();
+		$getParameter = (isset($_GET[$parameter]) && is_array($_GET[$parameter])) ? $_GET[$parameter] : array();
 
 		$mergedParameters = self::array_merge_recursive_overrule($getParameter, $postParameter);
 		self::stripSlashesOnArray($mergedParameters);
@@ -294,11 +300,15 @@
 	 * @return	mixed		If $var is set it returns the value of $_GET[$var]. If $var is NULL (default), returns $_GET itself. In any case *slashes are stipped from the output!*
 	 * @see _POST(), _GP(), _GETset()
 	 */
-	public static function _GET($var=NULL)	{
+	public static function _GET($var = NULL) {
 		$value = ($var === NULL) ? $_GET : (empty($var) ? NULL : $_GET[$var]);
-		if (isset($value))	{	// Removes slashes since TYPO3 has added them regardless of magic_quotes setting.
+		if (isset($value)) { // Removes slashes since TYPO3 has added them regardless of magic_quotes setting.
-			if (is_array($value))	{ self::stripSlashesOnArray($value); } else { $value = stripslashes($value); }
+			if (is_array($value)) {
+				self::stripSlashesOnArray($value);
+			} else {
+				$value = stripslashes($value);
-		}
+			}
+		}
 		return $value;
 	}
 
@@ -311,11 +321,15 @@
 	 * @return	mixed		If $var is set it returns the value of $_POST[$var]. If $var is NULL (default), returns $_POST itself. In any case *slashes are stipped from the output!*
 	 * @see _GET(), _GP()
 	 */
-	public static function _POST($var=NULL)	{
+	public static function _POST($var = NULL) {
 		$value = ($var === NULL) ? $_POST : (empty($var) ? NULL : $_POST[$var]);
-		if (isset($value))	{	// Removes slashes since TYPO3 has added them regardless of magic_quotes setting.
+		if (isset($value)) { // Removes slashes since TYPO3 has added them regardless of magic_quotes setting.
-			if (is_array($value))	{ self::stripSlashesOnArray($value); } else { $value = stripslashes($value); }
+			if (is_array($value)) {
+				self::stripSlashesOnArray($value);
+			} else {
+				$value = stripslashes($value);
-		}
+			}
+		}
 		return $value;
 	}
 
@@ -324,16 +338,16 @@
 	 * Usage: 2
 	 *
 	 * @param mixed $inputGet
-	 *        array or single value to write to $_GET. Values should NOT be
+	 *		array or single value to write to $_GET. Values should NOT be
-	 *        escaped at input time (but will be escaped before writing
+	 *		escaped at input time (but will be escaped before writing
-	 *        according to TYPO3 standards).
+	 *		according to TYPO3 standards).
 	 * @param string $key
-	 *        alternative key; If set, this will not set the WHOLE GET array,
+	 *		alternative key; If set, this will not set the WHOLE GET array,
-	 *        but only the key in it specified by this value!
+	 *		but only the key in it specified by this value!
-	 *        You can specify to replace keys on deeper array levels by
+	 *		You can specify to replace keys on deeper array levels by
-	 *        separating the keys with a pipe.
+	 *		separating the keys with a pipe.
-	 *        Example: 'parentKey|childKey' will result in
+	 *		Example: 'parentKey|childKey' will result in
-	 *        array('parentKey' => array('childKey' => $inputGet))
+	 *		array('parentKey' => array('childKey' => $inputGet))
 	 *
 	 * @return	void
 	 */
@@ -382,13 +396,19 @@
 	 * @deprecated since TYPO3 3.6, will be removed in TYPO3 4.6 - Use t3lib_div::_GP instead (ALWAYS delivers a value with un-escaped values!)
 	 * @see _GP()
 	 */
-	public static function GPvar($var,$strip=0)	{
+	public static function GPvar($var, $strip = 0) {
 		self::logDeprecatedFunction();
 
-		if(empty($var)) return;
+		if (empty($var)) {
+			return;
+		}
 		$value = isset($_POST[$var]) ? $_POST[$var] : $_GET[$var];
-		if (isset($value) && is_string($value))	{ $value = stripslashes($value); }	// Originally check '&& get_magic_quotes_gpc() ' but the values of $_GET are always slashed regardless of get_magic_quotes_gpc() because HTTP_POST/GET_VARS are run through addSlashesOnArray in the very beginning of index_ts.php eg.
-		if ($strip && isset($value) && is_array($value)) { self::stripSlashesOnArray($value); }
+		if (isset($value) && is_string($value)) {
+			$value = stripslashes($value);
+		} // Originally check '&& get_magic_quotes_gpc() ' but the values of $_GET are always slashed regardless of get_magic_quotes_gpc() because HTTP_POST/GET_VARS are run through addSlashesOnArray in the very beginning of index_ts.php eg.
+		if ($strip && isset($value) && is_array($value)) {
+			self::stripSlashesOnArray($value);
+		}
 		return $value;
 	}
 
@@ -401,7 +421,7 @@
 	 * @deprecated since TYPO3 3.7, will be removed in TYPO3 4.6 - Use t3lib_div::_GPmerged instead
 	 * @see _GP()
 	 */
-	public static function GParrayMerged($var)	{
+	public static function GParrayMerged($var) {
 		self::logDeprecatedFunction();
 
 		return self::_GPmerged($var);
@@ -416,21 +436,13 @@
 	 * @param	string		Input string
 	 * @return	string		Input string with potential XSS code removed
 	 */
-	public static function removeXSS($string)	{
+	public static function removeXSS($string) {
-		require_once(PATH_typo3.'contrib/RemoveXSS/RemoveXSS.php');
+		require_once(PATH_typo3 . 'contrib/RemoveXSS/RemoveXSS.php');
 		$string = RemoveXSS::process($string);
 		return $string;
 	}
 
 
-
-
-
-
-
-
-
-
 	/*************************
 	 *
 	 * IMAGE FUNCTIONS
@@ -442,35 +454,35 @@
 	 * Compressing a GIF file if not already LZW compressed.
 	 * This function is a workaround for the fact that ImageMagick and/or GD does not compress GIF-files to their minimun size (that is RLE or no compression used)
 	 *
-	 * 		The function takes a file-reference, $theFile, and saves it again through GD or ImageMagick in order to compress the file
+	 *		 The function takes a file-reference, $theFile, and saves it again through GD or ImageMagick in order to compress the file
-	 * 		GIF:
+	 *		 GIF:
-	 * 		If $type is not set, the compression is done with ImageMagick (provided that $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw'] is pointing to the path of a lzw-enabled version of 'convert') else with GD (should be RLE-enabled!)
+	 *		 If $type is not set, the compression is done with ImageMagick (provided that $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw'] is pointing to the path of a lzw-enabled version of 'convert') else with GD (should be RLE-enabled!)
-	 * 		If $type is set to either 'IM' or 'GD' the compression is done with ImageMagick and GD respectively
+	 *		 If $type is set to either 'IM' or 'GD' the compression is done with ImageMagick and GD respectively
-	 * 		PNG:
+	 *		 PNG:
-	 * 		No changes.
+	 *		 No changes.
 	 *
-	 * 		$theFile is expected to be a valid GIF-file!
+	 *		 $theFile is expected to be a valid GIF-file!
-	 * 		The function returns a code for the operation.
+	 *		 The function returns a code for the operation.
 	 * Usage: 9
 	 *
 	 * @param	string		Filepath
 	 * @param	string		See description of function
 	 * @return	string		Returns "GD" if GD was used, otherwise "IM" if ImageMagick was used. If nothing done at all, it returns empty string.
 	 */
-	public static function gif_compress($theFile, $type)	{
+	public static function gif_compress($theFile, $type) {
 		$gfxConf = $GLOBALS['TYPO3_CONF_VARS']['GFX'];
-		$returnCode='';
+		$returnCode = '';
-		if ($gfxConf['gif_compress'] && strtolower(substr($theFile,-4,4))=='.gif')	{	// GIF...
+		if ($gfxConf['gif_compress'] && strtolower(substr($theFile, -4, 4)) == '.gif') { // GIF...
-			if (($type=='IM' || !$type) && $gfxConf['im'] && $gfxConf['im_path_lzw'])	{	// IM
+			if (($type == 'IM' || !$type) && $gfxConf['im'] && $gfxConf['im_path_lzw']) { // IM
-				$cmd = self::imageMagickCommand('convert', '"'.$theFile.'" "'.$theFile.'"', $gfxConf['im_path_lzw']);
+				$cmd = self::imageMagickCommand('convert', '"' . $theFile . '" "' . $theFile . '"', $gfxConf['im_path_lzw']);
 				exec($cmd);
 
-				$returnCode='IM';
+				$returnCode = 'IM';
-			} elseif (($type=='GD' || !$type) && $gfxConf['gdlib'] && !$gfxConf['gdlib_png'])	{	// GD
+			} elseif (($type == 'GD' || !$type) && $gfxConf['gdlib'] && !$gfxConf['gdlib_png']) { // GD
 				$tempImage = imageCreateFromGif($theFile);
 				imageGif($tempImage, $theFile);
 				imageDestroy($tempImage);
-				$returnCode='GD';
+				$returnCode = 'GD';
 			}
 		}
 		return $returnCode;
@@ -484,17 +496,17 @@
 	 * @param	string		$theFile	the filename with path
 	 * @return	string		new filename
 	 */
-	public static function png_to_gif_by_imagemagick($theFile)	{
+	public static function png_to_gif_by_imagemagick($theFile) {
 		if ($GLOBALS['TYPO3_CONF_VARS']['FE']['png_to_gif']
-			&& $GLOBALS['TYPO3_CONF_VARS']['GFX']['im']
-			&& $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw']
+				&& $GLOBALS['TYPO3_CONF_VARS']['GFX']['im']
+				&& $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw']
-			&& strtolower(substr($theFile,-4,4))=='.png'
+				&& strtolower(substr($theFile, -4, 4)) == '.png'
-			&& @is_file($theFile))	{	// IM
+				&& @is_file($theFile)) { // IM
-				$newFile = substr($theFile,0,-4).'.gif';
+			$newFile = substr($theFile, 0, -4) . '.gif';
-				$cmd = self::imageMagickCommand('convert', '"'.$theFile.'" "'.$newFile.'"', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw']);
+			$cmd = self::imageMagickCommand('convert', '"' . $theFile . '" "' . $newFile . '"', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path_lzw']);
-				exec($cmd);
-				$theFile = $newFile;
-					// unlink old file?? May be bad idea bacause TYPO3 would then recreate the file every time as TYPO3 thinks the file is not generated because it's missing!! So do not unlink $theFile here!!
+			exec($cmd);
+			$theFile = $newFile;
+				// unlink old file?? May be bad idea bacause TYPO3 would then recreate the file every time as TYPO3 thinks the file is not generated because it's missing!! So do not unlink $theFile here!!
 		}
 		return $theFile;
 	}
@@ -508,37 +520,26 @@
 	 * @param	boolean		If set, then input file is converted to PNG, otherwise to GIF
 	 * @return	string		If the new image file exists, it's filepath is returned
 	 */
-	public static function read_png_gif($theFile,$output_png=0)	{
+	public static function read_png_gif($theFile, $output_png = 0) {
-		if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im'] && @is_file($theFile))	{
+		if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im'] && @is_file($theFile)) {
-			$ext = strtolower(substr($theFile,-4,4));
+			$ext = strtolower(substr($theFile, -4, 4));
 			if (
-					((string)$ext=='.png' && $output_png)	||
+				((string) $ext == '.png' && $output_png) ||
-					((string)$ext=='.gif' && !$output_png)
+				((string) $ext == '.gif' && !$output_png)
-				)	{
+			) {
 				return $theFile;
 			} else {
-				$newFile = PATH_site.'typo3temp/readPG_'.md5($theFile.'|'.filemtime($theFile)).($output_png?'.png':'.gif');
+				$newFile = PATH_site . 'typo3temp/readPG_' . md5($theFile . '|' . filemtime($theFile)) . ($output_png ? '.png' : '.gif');
-				$cmd = self::imageMagickCommand('convert', '"'.$theFile.'" "'.$newFile.'"', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path']);
+				$cmd = self::imageMagickCommand('convert', '"' . $theFile . '" "' . $newFile . '"', $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path']);
 				exec($cmd);
-				if (@is_file($newFile))	return $newFile;
+				if (@is_file($newFile)) {
+					return $newFile;
-			}
-		}
-	}
+				}
+			}
+		}
+	}
 
 
-
-
-
-
-
-
-
-
-
-
-
-
-
 	/*************************
 	 *
 	 * STRING FUNCTIONS
